/*
TODO: 
  make a query
  draw a Bar (3.2h*6 long by h high)
  make 6 subdivisions of the bar
  [impl both by drawing a box with fill color x and stroke black x 6]
  nope further subdivide: instead of 1 bibg box, loop which draws 12 little boxes.
  fine sub div width = 3.2h/12
  actual height is 3 h simply because space around the image is needed, simlarly, length is 7 boxes, not 6 to give a border.
*/

import de.bezier.data.sql.*;
BufferedReader queryLoader;

MySQL msql;
String query="";
String next;
int totalBooks;

int [] totalCheckouts;
int [] totalPerMonth;
int [][] individualCount;
int [][] individualCountYear;
int [] totalPerYear;
color [] colors = {color(0,0,255),color(0,255,0),color(255,0,0),color(255,0,255),color(255,255,0)};
//color [][] colors= {{color(0,0,255),color(0,255,0),color(255,0,0),color(255,0,255),color(255,255,0),color(0,255,255),color(125,125,255),color(185,200,100),color(255,125,125),color(125,125,125)},color [] colors= {color(0,0,200),color(0,200,0),color(200,0,0),color(200,0,200),color(200,200,0),color(0,200,200),color(75,75,200),color(135,150,50),color(200,75,75),color(75,75,75)}};
String [] titles = { "Lord of the Rings\nReturn of the King","The Hobbit or There\nand Back Again","Game of Thrones","Name of the Wind\nthe Kingkiller Chronicles","American Gods"};
//google data block
//collected Ind = totals for individuals
int [][]collectedInd={{454, 681, 1010, 1448, 1842, 3281, 2788, 464},{171, 115, 104, 109, 111, 114, 119, 27},{1272, 1128, 1137, 1122, 1158, 1654, 1540, 263},{2, 0, 0, 0, 29, 902, 1717, 234},{107, 95, 106, 104, 116, 222, 653, 231}};
//totals per year
int [][]collected = {{52, 117, 0, 0, 0}, {45, 111, 0, 0, 0}, {14, 111, 0, 0, 0}, {33, 105, 0, 0, 0}, {9, 113, 10, 0, 0}, {12, 191, 613, 0, 0}, {7, 602, 1181, 0, 0}};
float [][] xV;
float [][] yV;
int [] cT;
int [] cIndT;
//
int w = 800;
int h = 800;
int brOff=w/14;
int tickMarkLength=10;
int pointRad=5;
int legendSpace=w/5;
int titleSpace=h/10;
int hH =h-titleSpace-brOff;
int wH =w-legendSpace-brOff;
float wzoomm1=1;
float hzoomm1=1;
int tOff=5;
int radSmall=2;
int radLarge=10;
int legendBox=10;
int legendOff=legendBox+5;
int mode=0;

String xPer;
String yPer;

void setup(){
  //noLoop();
  smooth();
  size(w,h);
cIndT = new int[5];  
cT = new int[7];
//prep google data
for(int i=0; i<collectedInd.length; i++){
    for(int j =0; j<collectedInd[0].length-1; j++){
      cIndT[i]+=collectedInd[i][j];
    }
}
for(int i=0; i<collected.length; i++){
    for(int j =0; j<collected[0].length; j++){
      cT[i]+=collected[i][j];
    }
}  
  
queryLoader = createReader("Query.txt");
try{
  //load the query from file (to long for anyuthing else)
while ((next = queryLoader.readLine()) !=null)
  query+=" "+next;
} catch (IOException e){
  exit();
}

totalCheckouts = new int [5];
totalPerMonth = new int [85];
individualCount = new int [5][85];
individualCountYear = new int [5][7];
totalPerYear = new int [7];
xV = new float [5][7];
yV = new float [5][7];
  
  msql = new MySQL(this, "tango.mat.ucsb.edu","spl1","mat259","V1sual1zat1on");
 if ( msql.connect() )
  {
      msql.query(query);
      for (int i=0; i<85; i++){
        msql.next();
        for (int j=2; j<=6; j++){
          //collect all the relevant data points
          individualCount[j-2][i]=msql.getInt(j);
          totalCheckouts[j-2]+=msql.getInt(j);
          totalPerMonth[i]+=msql.getInt(j);
          if(i==84)
            continue;
          individualCountYear[j-2][i/12]+=msql.getInt(j);
          totalPerYear[i/12]+=msql.getInt(j);
        }
      }
  }
  else
  {
      // connection failed !
  }


}
/*
todo: draw a simple plot, plot the flow graph
current color
*/



void draw(){
  
  if (mode == 0){
      float x = mouseX;
      float y = mouseY;  
      x = (x<brOff)? brOff: x;
      x = (x>w-legendSpace)? w-legendSpace:x;
      y = (y<titleSpace)?titleSpace:y;
      y = (y>h-brOff)?h-brOff:y;
      x-=brOff;
      y=h-y-brOff;
      x/=(w-(brOff+legendSpace));
      y/=(h-(brOff+titleSpace));
      xPer = nfc(100*(1-x),2);
      yPer = nfc(100*(1-y),2);
      for (int i=0; i<7; i++){
      for (int j=0; j<5; j++){
        xV[j][i]=1+(wH*wzoomm1*(x*individualCountYear[j][i]/totalPerYear[i]+(1-x)*collected[i][j]/cT[i]))+brOff;
        yV[j][i]=(h-brOff)-(hH*hzoomm1*(y*individualCountYear[j][i]/totalCheckouts[j]+(1-y)*collectedInd[j][i]/cIndT[j]));
      }}  
  }
  textSize(12);
  background(255);
  line(brOff, h-brOff,w-legendSpace,h-brOff);
  line(brOff, titleSpace ,brOff,h-brOff);
  for (int i=0; i<7; i++){
  for (int j=0; j<5; j++){
    stroke(0);
    fill(colors[j]);
    int rad =(int)(radSmall+(radLarge-radSmall)*(i/7.));
      //stroke(colors[j]);
     fill(colors[j],200);
     ellipse(xV[j][i]+rad,yV[j][i]-rad,2*rad,2*rad);
      if(i==6)
        continue;
   stroke(colors[j],255/20*(10+j));
   line(xV[j][i]+pointRad,yV[j][i]-pointRad,xV[j][(i+8)%7]+pointRad,yV[j][(i+8)%7]-pointRad);
   }
  }
  
  if(mode ==1 && mouseX>brOff && mouseX<(w-legendSpace) && mouseY > titleSpace && mouseY<h-brOff){
      line(brOff, mouseY,mouseX,mouseY);
      line(mouseX, h-brOff ,mouseX,mouseY);
       float x = mouseX;
      float y = mouseY;  
      x-=brOff;
      y=h-y-brOff;
      x/=(w-(brOff+legendSpace));
      y/=(h-(brOff+titleSpace));
      String xL = nfc(100*(x),2);
      String yL = nfc(100*(y),2);
      textAlign(BOTTOM,LEFT);
      stroke(0);
      fill(0);
      text(xL+"% "+yL+"%", mouseX, mouseY);
  }
   // do chart labels
   stroke(0);
   fill(0);
   textAlign(CENTER,CENTER);
   textSize(12);
   text("Individual Count/ Year Total", w/2,h-brOff/2);
     pushMatrix();
    translate(tOff,h/2);
    rotate(-HALF_PI);
     text("Individual Count/ Total in all years",0,0);
    popMatrix();
 textSize(18);
 text("Popularity over Time Versus Popularity per Year", w/2,titleSpace/2);   tickMarks(wzoomm1,hzoomm1);
/*
form the legend
use 1/8 margins top/bot
*/
textAlign(LEFT,TOP);
for (int i=0; i<5; i++){
  fill(colors[i]);
  noStroke();
  rect(w-4*legendSpace/5,h/8+3*h/4/10*i,legendBox,legendBox);
  fill(0);
  stroke(0);
  text(titles[i],w-4*legendSpace/5,h/8+3*h/4/10*i+legendOff);
}

text("Percentage of x axis\nusing google data:"+xPer,w-4*legendSpace/5,h/8+3*h/4/10*7+legendOff);
text("Percentage of y axis\nusing google data:"+yPer,w-4*legendSpace/5,h/8+3*h/4/10*8+legendOff);

}

void tickMarks(float xScaling, float yScaling){
  textSize(10);
   for (int i=0; i<=10; i++){
     line(brOff+wH/10*i,h-brOff,brOff+wH/10*i,h-brOff+tickMarkLength); //x tick
     line(brOff,h-brOff-i*hH/10,brOff-tickMarkLength,h-brOff-i*hH/10); //y tick
     String x = nfc(100./xScaling/10*i,2);
     String y = nfc(100./yScaling/10*i,2);
     x+="%";
     y+="%";
     textAlign(CENTER,TOP);
     text(x,brOff+wH/10*i,h-brOff+tickMarkLength+tOff); //x label
     textAlign(RIGHT,CENTER);
     text(y,brOff-tickMarkLength,h-brOff-i*hH/10+tOff); //y label
     
 }
}

void mousePressed(){
   mode+=1;
   mode = mode%2;
}
